package com.castlabs.sdk.hdcp_demo;

import android.Manifest;
import android.content.Intent;
import android.content.pm.PackageManager;
import android.os.Build;
import android.os.Bundle;

import androidx.appcompat.app.AppCompatActivity;

import com.castlabs.android.SdkConsts;
import com.castlabs.android.player.PlayerConfig;

public class MainActivity extends AppCompatActivity {

	public static final String INTENT_PLAYLIST = "INTENT_PLAYLIST";

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);

		PlayerConfig[] configs = new PlayerConfig[1];
		PlayerConfig config = new PlayerConfig.Builder("192.168.88.254:4999")
			.contentType(SdkConsts.CONTENT_TYPE_GSTREAMER)
			.live(true)
			.get();

		configs[0] = config;

		Bundle bundle = new Bundle();
		bundle.putParcelableArray(INTENT_PLAYLIST, configs);
		MainActivity.this.startActivity(new Intent(MainActivity.this,
			SingleControllerPlaylistDemo.class).putExtras(bundle));

		checkPermissions();
	}

	private void checkPermissions() {
		if (Build.VERSION.SDK_INT >= 23) {
			if (!(checkSelfPermission(Manifest.permission.ACCESS_COARSE_LOCATION) == PackageManager.PERMISSION_GRANTED)) {
				requestPermissions(new String[]{Manifest.permission.ACCESS_COARSE_LOCATION}, 0);
			}
		}

		if (Build.VERSION.SDK_INT >= 29) {
			if (!(checkSelfPermission(Manifest.permission.ACCESS_FINE_LOCATION) == PackageManager.PERMISSION_GRANTED)) {
				requestPermissions(new String[]{Manifest.permission.ACCESS_FINE_LOCATION}, 0);
			}
		}
	}

}
